scala.tools.nsc.javac.JavaParsers

# JavaParser

###
Related Doc: package JavaParsers

#### abstract class JavaParser extends ParserCommon

Source
  JavaParsers.scala

Linear Supertypes
JavaParsers.ParserCommon, AnyRef, Any
Known Subclasses
JavaUnitParser
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. JavaParser
2. ParserCommon
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new JavaParser()

### Abstract Value Members

1. #### abstract def deprecationWarning(off: JavaParsers.Offset, msg: String): Unit

   Definition Classes
     ParserCommon

2. #### abstract def freshName(prefix: String): Global.Name

3. #### implicit abstract def i2p(offset: Int): Global.Position

   Attributes
     protected

4. #### abstract val in: JavaParsers.JavaScanner

   Definition Classes
     JavaParser → ParserCommon

5. #### abstract def syntaxError(pos: Int, msg: String): Unit

6. #### abstract def warning(pos: Int, msg: String): Unit

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from JavaParser to any2stringadd[JavaParser] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (JavaParser, B)

   Implicit information
     This member is added by an implicit conversion from JavaParser to ArrowAssoc[JavaParser] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### def accept(token: Int): Int

   Consume one token of the specified type, or signal an error if it is not there.

   Consume one token of the specified type, or signal an error if it is not there.

   Definition Classes
     JavaParser → ParserCommon

7. #### def acceptClosingAngle(): Unit

8. #### def addCompanionObject(statics: List[Global.Tree], cdef: Global.ClassDef): List[Global.Tree]

9. #### def annotation(): Unit

   Annotation ::= TypeName [`(` AnnotationArgument {`,` AnnotationArgument} `)`]

10. #### def annotationDecl(mods: Global.Modifiers): List[Global.Tree]

11. #### def annotationParents: collection.immutable.List[Global.Select]

12. #### def annotations(): List[Global.Tree]

13. #### def arrayOf(tpt: Global.Tree): Global.AppliedTypeTree

14. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

15. #### def basicType(): Global.Tree

16. #### def blankExpr: Global.Ident

17. #### def bound(): Global.Tree

18. #### def classDecl(mods: Global.Modifiers): List[Global.Tree]

19. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

20. #### def compilationUnit(): Global.Tree

    CompilationUnit ::= [package QualId semi] TopStatSeq

21. #### def convertToTypeId(tree: Global.Tree): Global.Tree

    Convert (qual)ident to type identifier

22. #### def definesInterface(token: Int): Boolean

23. #### final def dropAnyBraces[T](body: ⇒ T): T

    Definition Classes
      ParserCommon
    Annotations
      @inline()

24. #### def ensuring(cond: (JavaParser) ⇒ Boolean, msg: ⇒ Any): JavaParser

    Implicit information
      This member is added by an implicit conversion from JavaParser to Ensuring[JavaParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

25. #### def ensuring(cond: (JavaParser) ⇒ Boolean): JavaParser

    Implicit information
      This member is added by an implicit conversion from JavaParser to Ensuring[JavaParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

26. #### def ensuring(cond: Boolean, msg: ⇒ Any): JavaParser

    Implicit information
      This member is added by an implicit conversion from JavaParser to Ensuring[JavaParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

27. #### def ensuring(cond: Boolean): JavaParser

    Implicit information
      This member is added by an implicit conversion from JavaParser to Ensuring[JavaParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

28. #### def enumConst(enumType: Global.Tree): (Global.ValDef, Boolean)

29. #### def enumDecl(mods: Global.Modifiers): List[Global.Tree]

30. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

31. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

32. #### def errorTypeTree: Global.TypeTree

33. #### def fieldDecls(pos: Global.Position, mods: Global.Modifiers, tpt: Global.Tree, name: Global.Name): List[Global.Tree]

    Parse a sequence of field declarations, separated by commas.

    Parse a sequence of field declarations, separated by commas. This one is tricky because a comma might also appear in an initializer. Since we don't parse initializers we don't know what the comma signifies. We solve this with a second list buffer `maybe` which contains potential variable definitions. Once we have reached the end of the statement, we know whether these potential definitions are real or not.

34. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

35. #### def formalParam(): Global.ValDef

36. #### def formalParams(): List[Global.ValDef]

37. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from JavaParser to StringFormat[JavaParser] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

38. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

39. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

40. #### def ident(): Global.Name

41. #### def identForType(): Global.TypeName

42. #### def importCompanionObject(cdef: Global.ClassDef): Global.Tree

43. #### def importDecl(): List[Global.Tree]

44. #### final def inBraces[T](body: ⇒ T): T

    Definition Classes
      ParserCommon
    Annotations
      @inline()

45. #### final def inBracesOrError[T](body: ⇒ T, alt: T): T

    Definition Classes
      ParserCommon
    Annotations
      @inline()

46. #### final def inBracesOrNil[T](body: ⇒ List[T]): List[T]

    Definition Classes
      ParserCommon
    Annotations
      @inline()

47. #### final def inBracesOrUnit[T](body: ⇒ Global.Tree): Global.Tree

    Definition Classes
      ParserCommon
    Annotations
      @inline()

48. #### final def inBrackets[T](body: ⇒ T): T

    Definition Classes
      ParserCommon
    Annotations
      @inline()

49. #### final def inParens[T](body: ⇒ T): T

    Methods inParensOrError and similar take a second argument which, should the next token not be the expected opener (e.g.

    Methods inParensOrError and similar take a second argument which, should the next token not be the expected opener (e.g. LPAREN) will be returned instead of the contents of the groupers. However in all cases accept(LPAREN) will be called, so a parse error will still result. If the grouping is optional, in.token should be tested before calling these methods.

    Definition Classes
      ParserCommon
    Annotations
      @inline()

50. #### final def inParensOrError[T](body: ⇒ T, alt: T): T

    Definition Classes
      ParserCommon
    Annotations
      @inline()

51. #### final def inParensOrNil[T](body: ⇒ List[T]): List[T]

    Definition Classes
      ParserCommon
    Annotations
      @inline()

52. #### final def inParensOrUnit[T](body: ⇒ Global.Tree): Global.Tree

    Definition Classes
      ParserCommon
    Annotations
      @inline()

53. #### def interfaceDecl(mods: Global.Modifiers): List[Global.Tree]

54. #### def interfacesOpt(): List[Global.Tree]

55. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

56. #### def javaDot(name: Global.Name): Global.Tree

57. #### def javaLangDot(name: Global.Name): Global.Tree

58. #### def javaLangObject(): Global.Tree

59. #### def makeCompanionObject(cdef: Global.ClassDef, statics: List[Global.Tree]): Global.Tree

60. #### def makeConstructor(formals: List[Global.Tree]): Global.DefDef

61. #### def makePackaging(pkg: Global.RefTree, stats: List[Global.Tree]): Global.PackageDef

62. #### def makeParam(name: Global.TermName, tpt: Global.Tree): Global.ValDef

63. #### def makeParam(name: String, tpt: Global.Tree): Global.ValDef

64. #### final def makeParens(body: ⇒ List[Global.Tree]): Global.Parens

    Creates an actual Parens node (only used during parsing.)

    Creates an actual Parens node (only used during parsing.)

    Definition Classes
      ParserCommon
    Annotations
      @inline()

65. #### def makeSyntheticParam(count: Int, tpt: Global.Tree): Global.ValDef

66. #### def makeTemplate(parents: List[Global.Tree], stats: List[Global.Tree]): Global.Template

67. #### def memberDecl(mods: Global.Modifiers, parentToken: Int): List[Global.Tree]

68. #### def methodBody(): Global.Tree

69. #### def modifiers(inInterface: Boolean): Global.Modifiers

70. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

71. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

72. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

73. #### def optArrayBrackets(tpt: Global.Tree): Global.Tree

74. #### def optThrows(): Unit

75. #### def parse(): Global.Tree

    this is the general parse method

76. #### def qualId(): Global.RefTree

77. #### def repsep[T <: Global.Tree](p: () ⇒ T, sep: Int): List[T]

78. #### def skip(): Unit

    Attributes
      protected

79. #### def skipAhead(): Unit

    skip parent or brace enclosed sequence of things

80. #### def skipTo(tokens: Int*): Unit

81. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

82. #### def syntaxError(pos: Int, msg: String, skipIt: Boolean): Unit

83. #### def syntaxError(msg: String, skipIt: Boolean): Unit

84. #### def termDecl(mods: Global.Modifiers, parentToken: Int): List[Global.Tree]

85. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

86. #### def typ(): Global.Tree

87. #### def typeArgs(t: Global.Tree): Global.Tree

88. #### def typeBody(leadingToken: Int, parentName: Global.Name): (List[Global.Tree], List[Global.Tree])

89. #### def typeBodyDecls(parentToken: Int, parentName: Global.Name): (List[Global.Tree], List[Global.Tree])

90. #### def typeDecl(mods: Global.Modifiers): List[Global.Tree]

91. #### def typeParam(): Global.TypeDef

92. #### def typeParams(): List[Global.TypeDef]

93. #### def varDecl(pos: Global.Position, mods: Global.Modifiers, tpt: Global.Tree, name: Global.TermName): Global.ValDef

94. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

95. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

96. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

97. #### def →[B](y: B): (JavaParser, B)

    Implicit information
      This member is added by an implicit conversion from JavaParser to ArrowAssoc[JavaParser] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from JavaParsers.ParserCommon

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from JavaParser to any2stringadd[JavaParser]

### Inherited by implicit conversion StringFormat from JavaParser to StringFormat[JavaParser]

### Inherited by implicit conversion Ensuring from JavaParser to Ensuring[JavaParser]

### Inherited by implicit conversion ArrowAssoc from JavaParser to ArrowAssoc[JavaParser]

### Ungrouped